LeetCode -Reverse Pairs

my solution:

class Solution {
public:
    int reversePairs(vector<int>& nums) {
        int length=nums.size();
        int count=0;
    for (int i=0;i<length;i++)
        {
            for(int j=i+1;j<length;j++)
            {
               if(nums[i]>2*nums[j])
                  count++;
            }
        }
        return count;
    }
};

wrong answer :

because   2147483647*2 is -2 (int)  ,  only 33bit can represent

 

int4 byte32 bit

2147483647--2147483647  signed

0-4294967295  unsigned

long4 byte32 bit(在 32 位机器上与int 相同)
double8 byte64 bit  1.79769e+308 ~ 2.22507e-308
float4 byte32 bit  3.40282e+038 ~ 1.17549e-038
long double12 byte96 bit 1.18973e+4932 ~ 3.3621e-4932

then i change the type to double:

class Solution {
public:
    int reversePairs(vector<int>& nums) {
        int length=nums.size();
        int count=0;
        double a;
        for (int i=0;i<length;i++)
        {
            for(int j=i+1;j<length;j++)
            {
                a=(double)2*nums[j];
                if(nums[i]>a)
                  count++;
            }
        }
        return count;
    }
};

wrong:

because the if the maxmise length is 50000, the process will lead to time exceed . 

对于这类问题,一种很好的解法就是拆分数组来解决子问题,通过求解小问题来求解大问题。

有两类拆分方法:

  •    顺序重现(sequential recurrence relation):T(i, j) = T(i, j - 1) + C
  •    C就是处理最后一个数字的子问题,找 T(i, j - 1)中的reverse pairs, T(i, j-1) 有序,只需要找大于2*nums[j]的数。     二分查找已经不满足条件了,只能使用Binary indexed tree 来实现。BIT的存储方式不是数组对应一一存入,而是有的对应存入,有的存若干个数字之和,其设计的初衷是在O(lgn)时间复杂度内完成求和运算。

             

  •    分割重现(Partition Recurrence relation):T(i, j) = T(i, m) + T(m+1, j) + C
  •         C为合并两个部分的子问题。MergeSort的思想就是把数组对半拆分为子数组,柴刀最小的数组后开始排序,然后一层一层返回,得到有序的数组。时间复杂度O(nlogn)
class Solution {
public:
    int reversePairs(vector<int>& nums) {
        return mergeSort(nums, 0, nums.size() - 1);
    }
    int mergeSort(vector<int>& nums, int left, int right) {
        if (left >= right) return 0;
        int mid = left + (right - left) / 2;
        int res = mergeSort(nums, left, mid) + mergeSort(nums, mid + 1, right);
        for (int i = left, j = mid + 1; i <= mid; ++i) {
            while (j <= right && nums[i] / 2.0 > nums[j]) ++j;
            res += j - (mid + 1);
        }
        sort(nums.begin() + left, nums.begin() + right + 1);
        return res;
    }
};

 

归并排序 MergeSort 和BIT可以解决,BST和 binary search不行

 

 

https://discuss.leetcode.com/topic/79227/general-principles-behind-problems-similar-to-reverse-pairsBST (binary search tree)

BIT (binary indexed tree)

 

转载于:https://www.cnblogs.com/fanhaha/p/7142651.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值